package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import java.util.Arrays;
import java.util.List;

@Component
public class ExampleClient {

    @Autowired
    private EmployeeRepository empRepo;
    @Autowired
    private DeptRepository deptRepo;


    public void run() {
        List<Employee> employees = createEmployees();
        empRepo.saveAll(employees);

        System.out.println(" -- finding by dept name IT --");
        List<Employee> list = empRepo.findByDeptName("IT");
        list.stream().forEach(System.out::println);

        System.out.println(" -- finding by dept entity Admin --");
        Dept admin = deptRepo.findByName("Admin");
        List<Employee> list2 = empRepo.findByDept(admin);
        list2.stream().forEach(System.out::println);
    }

    private List<Dept> createDepts() {
        return Arrays.asList(Dept.create("Admin"), Dept.create("IT"), Dept.create("Sale"));
    }

    private List<Employee> createEmployees() {
        Dept admin = Dept.create("Admin");
        Dept it = Dept.create("IT");
        Dept sale = Dept.create("Sale");
        return Arrays.asList(
                Employee.create("Diana", admin, 5000),
                Employee.create("Joe", it, 2000),
                Employee.create("Sophia", it, 6000),
                Employee.create("Mike", sale, 4000),
                Employee.create("Rose", it, 3000)
        );
    }
}